
--******************************************************************************************************
-- Created: 		02-05-2011
-- Last Updated:	15-05-2011
-- Version:			1.1
--
-- Author :  Kostadin Kotev / miau_u@yahoo.com /
-- Version:  3ds max 2009 (10) (should work in older versions too!)
--
-- Discription:
--	
-- 
-- Version History:
--	v1.0 - initial release
--		  - Extrude selected polygons alon selected axis - XY, XZ, YZ. The extrudet faces is keep their initial shape - straight or curve
--	v1.1 - add SYPHORLATE method of extrusion.
--		 - now the script can extrude in any direction. Pyramid and Sphere objects is problematic - use the standart axis extrude 
--		 - add the About page
--******************************************************************************************************
-- MODIFY THIS AT YOUR OWN RISK

macroscript SmartPolyExtrude_v10
category:"miauu"
tooltip:"Smart Poly Extride v1.0"
buttonText:"Smart Poly Extride"
(
	global PolyStraightExtrude
	try(destroyDialog PolyStraightExtrude)catch()
	rollout PolyStraightExtrude "Smart Poly Extrude v.1.1"
	(
		--	SYPHORLATE extrude method
		local curObj = undefined
		local tempObj = undefined
		local vertInfo = #()	--	contain the info for starting faces selection - #(i, faceNormal, faceVerts, faceSel01Verts)
		local getFacesInfo = false	--	to get or not the faces info
		local poGetFaceSelection = polyop.getFaceSelection
		local poGetFaceNormal = polyop.getFaceNormal
		local poGetFaceVerts = polyop.getFaceVerts
		local poGetVert = polyop.getVert
		local poSetVert = polyop.setVert
		--	STANDART Axis Poly Extrude
		local start = 0	--	used by timer
		local poGetOpenEdges = polyop.getOpenEdges
		local poGetEdgeSelection = polyop.getEdgeSelection
		local poSetEdgeSelection = polyop.setEdgeSelection
		local poGetFaceSelection = polyop.getFaceSelection
		local poGetVertsUsingFace = polyOp.getVertsUsingFace
		
		local uiX = 0
		local uiY = 0
			
		button btn_polyLoop "Loop" pos:[uiX+2,uiY+5] width:60 
		spinner spn_extrudeAmountS "Height:" fieldwidth:53 range:[-99999,99999,0] pos:[uiX+82,uiY+7] type:#worldunits
		spinner spn_extrudeAmount "Height:" fieldwidth:53 pos:[-300,-300]range:[-99999,99999,1] type:#worldunits scale:0.01 enabled:off
		button btn_Apply "Apply" pos:[uiX+2,uiY+32] width:60
		button btn_OK "OK" pos:[uiX+62,uiY+32] width:60
		button btn_Cancel "Cancel" pos:[uiX+122,uiY+32] width:60
		checkButton chkbtn_axisExtrude "Open Axis Extrude" pos:[uiX,uiY+57] width:154 height:20
		
		checkButton chkbtn_about "?" pos:[uiX+160,uiY+57] width:20 height:20 tooltip:"About"
		label lbl_1 "Smart Poly Extrude v1.1" pos:[230,5 ]
		label lbl_2 "Big thanks to SYPHORLATE" pos:[220,30]
		label lbl_3 "for his elegant extrusion method" pos:[212,50]
		
		local uiY1 = 80
		checkButton chkbtn_XY "" width:60 height:74 pos:[uiX+2,uiY1] images:#("PolyExtrudeIcons.png","PolyExtrudeIcons.png",6,4,1,4,1)
		checkButton chkbtn_XZ "" width:60 height:74 pos:[uiX+62,uiY1] images:#("PolyExtrudeIcons.png","PolyExtrudeIcons.png",6,5,2,5,2)
		checkButton chkbtn_YZ "" width:60 height:74 pos:[uiX+122,uiY1] images:#("PolyExtrudeIcons.png","PolyExtrudeIcons.png",6,6,3,6,3)

		--	error messages
		timer clockT "testClock" active:off interval:1000 --tick once per second
		dotNetControl dnLbl_errMsg "System.Windows.Forms.Label" pos:[0,uiY+160]  width:184 height:38
		
		on clockT tick do
		(
			start += 1
			if start >= 3 do 
			(
				if chkbtn_axisExtrude.state == false then
				(
					for h = 120 to 80 by -5 do
					(
						PolyStraightExtrude.height = h
						sleep 0.002					
					)
				)
				else
				(
					for h = 200 to 158 by -5 do
					(
						PolyStraightExtrude.height = h
						sleep 0.002
					)
				)
				dnLbl_errMsg.pos = [-300,-300]
				clockT.active = false
			)
		)
		function errorMessage errMsg =
		(		
			local errMssg
			case errMsg of
			(
				--	with red color
				1: errMssg = "Select Editable Poly object !"
				2: errMssg = "Go to Polygon subobject level !"
				3: errMssg = "Select 2 or more faces !"
				4: errMssg = "Triangles is not supported ! Deselect them !"
			)
			start = 0
			if chkbtn_axisExtrude.state == false then
			(
				for h = 80 to 120 by 5 do
				(
					PolyStraightExtrude.height = h
					sleep 0.002					
				)
				dnLbl_errMsg.pos = [0,uiY+80]
			)
			else
			(
				for h = 158 to 200 by 5 do
				(
					PolyStraightExtrude.height = h
					sleep 0.002					
				)
				dnLbl_errMsg.pos = [0,uiY+160]
			)
			dnLbl_errMsg.Text = errMssg
			dnLbl_errMsg.BorderStyle	= (dotNetClass "System.Windows.Forms.BorderStyle").fixedsingle
			--	use red color
				dnLbl_errMsg.BackColor	= (dotNetClass "System.Drawing.Color").FromArgb 111 33 33 
				dnLbl_errMsg.forecolor = (dotnetclass "System.Drawing.Color").FromArgb 237 184 27 
				dnLbl_errMsg.textalign = (dotnetclass "System.Drawing.ContentAlignment").middlecenter
				
				dnLbl_errMsg.font = dotNetObject "System.Drawing.Font" "Arial" 8
				dnFontStyle = dotNetClass "System.Drawing.FontStyle"
				myFontStyle = dotnet.combineenums dnFontStyle.bold
				dnLbl_errMsg.font = dotNetObject "System.Drawing.Font" "Arial" 8 myFontStyle	
			--	activate the timer
			clockT.active = true
		)
		--	check object and face selection
		function CheckObjAndFaceSelection =
		(
			state = true
			if selection.count == 1 then
			(
				local selObj = modpanel.getCurrentObject ()
				if classof selObj == Editable_Poly then
				(
					if subobjectlevel == 4 or subobjectlevel == 5 then
					(
						if ((poGetFaceSelection selObj) as array).count > 1 then
							state = true
						else
						(
							errorMessage 3
							state = false
						)
					)
					else
					(
						errorMessage 2
						state = false
					)
				)
				else
				(
					errorMessage 1
					state = false
				)
			)
			else
			(
				errorMessage 1
				state = false
			)
			state
		)
		--///	AXIS POLY EXTRUDE with Scale of the vertices
		function ExtrudePolygons val =
		(
			local curObj = selection[1]
			theHold.cancel()
			theHold.begin()
				
			faceSel01 = poGetFaceSelection  curObj 
			curObj.insetAmount = 0.0
			curObj.insetType = 0
			curObj.EditablePoly.buttonOp #Inset

			--	set the scale to Non-Uniform.
-- 			toolMode.nonUniformScale()
			
			-- find the center of selected faces
			vertsOfFaces = poGetVertsUsingFace curObj faceSel01			
			vertPos = for v in vertsOfFaces collect poGetVert curObj v			
			faceCenter = [0,0,0]
			for v in vertPos do faceCenter += v		
			faceCenter /= vertPos.count
			
			local scaleValues = undefined
			if chkbtn_XY.checked do (scaleValues = [val,val,1.0])
			if chkbtn_XZ.checked do (scaleValues = [val,1.0,val])
			if chkbtn_YZ.checked do (scaleValues = [1.0,val,val])	

			tmSM = (transMatrix -faceCenter)*(scaleMatrix scaleValues)*(transMatrix faceCenter)
			for v in vertsOfFaces do
			(
				vertPos = poGetVert curObj v
				vertPos = (vertPos*tmSM)
				poSetVert curObj v vertPos
			)
		)
		--///	SYPHORLATE Function modified by me for faster and better performance
		--	function below work proper with all type of face selection
		function InteractiveExtrudeFaces extrudeVal =
		(
			if getFacesInfo == false do
			(
				if CheckObjAndFaceSelection() == true do
				(
					--	select the current object
					curObj = $
					--	copy the object
					tempObj = copy curObj
					hide tempObj
					--	indicate that the faces info is already collected
					getFacesInfo = true
				)
			)
			
			theHold.cancel()
			theHold.begin()
			--Extrude the face selection using "Local Extrusion"
			curObj.extrusionType = 1
			curObj.extrudeFaces extrudeVal			
			
			faceSel02 = poGetFaceSelection curObj as array
			local continueExtr = true
			local notFound = true
			for f in faceSel02 while notFound do
			(
				if (curObj.GetFaceDegree f) == 3 do
				(
					continueExtr = false
					notFound = false
				)
			) 
			--	if there are no selected triangles do the extrusion
			if continueExtr == true then
			(
				--loop through the faces and correct the position of the vertices
				vx1=#()
				vx2=#()
				fid=#()--array which collects id's of vertices we have already changed 
				for f=1 to faceSel02.count do
				(
					v1 = poGetFaceVerts tempObj faceSel02[f]
					v2 = poGetFaceVerts curObj faceSel02[f]	

					--get face normal
					norm = polyop.getFaceNormal tempObj faceSel02[f]

					--	here's were the magic happens
					for i=1 to 4 do	--	work only with quads
					(
						if appendifunique fid v1[i] do
						(
							vx1 = poGetVert tempObj v1[i]
							vx2 = poGetVert curObj v2[i]
							
							--	get the vector which connects "extruded" and "unextruded" vertex
							vec1=normalize (vx2-vx1)
							vec2=norm
							
							--	calculate angle, apply inverted cosinus and offset 
							ang= acos( dot vec1 vec2) 
							--	quadratic correction factor
							fac=1.0 / (cos ang)
							if fac >= 1 and fac <= 1.5 do
							(
								--	for some reason we have to apply the correct sign to the factor
								vx2=vx1+fac*vec1*extrudeVal
								--	move the verts to its new position
								poSetVert curObj v2[i] vx2 
							)
						)
					)
				)
			)
			else
				errorMessage 4
		)
/* 		--	function below work proper with single face loop, with verts that have four common faces
			--	or with verts that have 3 common faces
		function InteractiveExtrudeFaces extrudeVal =
		(
			curObj = selection[1]
			--	get the info of selected faces only onace
			if getFacesInfo == false do
			(
				if CheckObjAndFaceSelection() == true do
				(
					vertInfo = #()
					faceSel01Verts = #()
					--	get starting face selection
					faceSel01 = poGetFaceSelection curObj as array
					for i in faceSel01 do
					(
						--	collect faces normals
						faceNormal = poGetFaceNormal curObj i
						--	collect faces verts
						faceVerts = poGetFaceVerts curObj i
						--	collect faces verts position
						for i in faceVerts do
						(
								vx1 = poGetVert curObj i
								append faceSel01Verts vx1
						) 
						--	store values to main array
						append vertInfo #( i, faceNormal, faceVerts, faceSel01Verts)
					)
					--	indicate that the faces info is already collected
					getFacesInfo = true
				)
			)
			
			theHold.cancel()
			theHold.begin()
			--Extrude the face selection using "Local Extrusion"
			curObj.extrusionType = 1
			curObj.extrudeFaces extrudeVal
			
			--	get the new faces - in fact that is the old faces but with new position in the scene
			faceSel02 = poGetFaceSelection  curObj as array
			--loop through the faces and correct the position of the vertices
			vx1=#()
			vx2=#()
			fid=#()--array which collects id's of vertices we have already changed 
			for f=1 to faceSel02.count do
			(
				v1 = vertInfo[f][3]
				v2 = poGetFaceVerts curObj faceSel02[f]

				--get face normal
				norm = vertInfo[f][2]

				--	here's were the magic happens
				for i=1 to 4 do
				(
					 if appendifunique fid v1[i] do
					 (
						--	work proper with single face loop and verts with up to 3 common faces
						vx1 = poGetVert curObj v1[i] 	--	old object - the original
						--	work proper with 4 selected faces that have 1 common vert or with coplanar faces
-- 						vx1 = vertInfo[f][4][i]--	old object - the original 
						
						vx2 = poGetVert curObj v2[i]

						--	get the vector which connects "extruded" and "unextruded" vertex
						vec1=normalize (vx2-vx1)
						vec2=norm
						
						--	calculate angle, apply inverted cosinus and offset 
						ang= acos( dot vec1 vec2) 
						--	quadratic correction factor
						fac=1.0 / (cos ang)
						--	for some reason we have to apply the correct sign to the factor
						vx2=vx1+fac*vec1*extrudeVal
						--	move the verts to its new position
						poSetVert curObj v2[i] vx2 
					)
				)
			)
		) */
		--	select face loop
		on btn_polyLoop pressed do
		(
			if CheckObjAndFaceSelection() == true do
			(
				local curObj = $.baseobject
				local edgeSel01 = poGetEdgeSelection  curObj
				local faceSel01 = polyop.getFaceSelection curObj
				if faceSel01.numberSet >= 2 then
				(
					local edgesOfFace = polyop.getEdgesUsingFace curobj faceSel01
					curObj.EditablePoly.ConvertSelectionToBorder #Face #Edge
					local outerEdges = polyop.getEdgeSelection curObj
					local innerEdges = edgesOfFace-outerEdges
					polyop.setEdgeSelection curObj innerEdges
					curObj.EditablePoly.SelectEdgeRing ()
					curObj.EditablePoly.ConvertSelection #Edge #Face
					poSetEdgeSelection curObj edgeSel01
					redrawviews()
				)
			)	
		)
		
		on spn_extrudeAmountS changed val do
		(
			InteractiveExtrudeFaces val
		)
		--	Axis Extrude
		on spn_extrudeAmount changed val do
		(
			ExtrudePolygons val
		)
		
		on btn_Apply pressed do
		(
			theHold.accept "Poly Extrude"
			spn_extrudeAmountS.value = 0.0
			spn_extrudeAmount.value = 1.0
			getFacesInfo = false
			vertInfo = #()
			try(delete tempObj)catch()
			curObj = undefined
			tempObj = undefined
		)
		
		on btn_OK pressed do
		(
			theHold.accept "Poly Extrude"		
			destroyDialog PolyStraightExtrude
			try(delete tempObj)catch()
			curObj = undefined
			tempObj = undefined
		)		
		
		on btn_Cancel pressed do
		(
			theHold.cancel()
			redrawViews()
			spn_extrudeAmountS.value = 0.0
			spn_extrudeAmount.value = 1.0
			getFacesInfo = false
			vertInfo = #()
			try(delete tempObj)catch()
			curObj = undefined
			tempObj = undefined
		)
		--	open the axis icons rollout
		on chkbtn_axisExtrude changed theState do
		(
			if theState then
			(
				--	swap the places of the two spinners
				--	hide the S spinner
				spn_extrudeAmountS.pos = [-300,-300]
				--	show the axis extrude spinner
				spn_extrudeAmount.pos = [uiX+168,uiY+7]
				--	set the value to 1.0 because the scale don't work with 0.0
				spn_extrudeAmountS.value = 1.0
				chkbtn_axisExtrude.text = "Close Axis Extrude"
				--	show the axis extrude controls
				chkbtn_XY.pos = [uiX+2,uiY1]
				chkbtn_XZ.pos = [uiX+62,uiY1]
				chkbtn_YZ.pos = [uiX+122,uiY1]
				--	extend the dialog height
				for h = 80 to 158 by 5 do
				(
					PolyStraightExtrude.height = h
					sleep 0.002
				)
			)
			else
			(
				--	swap the places of the two spinners
				--	show the S spinner
				spn_extrudeAmountS.pos = [uiX+168,uiY+7]
				--	hide the axis extrude spinner
				spn_extrudeAmount.pos = [-300,-300]
				chkbtn_axisExtrude.text = "Open Axis Extrude"
				for h = 158 to 80 by -5 do
				(
					PolyStraightExtrude.height = h
					sleep 0.002
				)
				chkbtn_XY.state = false
				chkbtn_XZ.state = false
				chkbtn_YZ.state = false
				spn_extrudeAmount.enabled = false
			)
		)		
		--	define the axis of extrusion
		on chkbtn_XY changed theState do
		(
			if theState then
			( 
				if CheckObjAndFaceSelection() == true then
				(
					chkbtn_XZ.state = false
					chkbtn_YZ.state = false
					spn_extrudeAmount.enabled = on
				)
				else
				(
					chkbtn_XY.state = false
				)
			)
			else
			(
				chkbtn_XY.state = true	
			)
		)
		on chkbtn_XZ changed theState do
		(
			if theState then
			(
				if CheckObjAndFaceSelection() == true then
				(
					chkbtn_XY.state = false
					chkbtn_YZ.state = false
					spn_extrudeAmount.enabled = on
				)
				else
				(
					chkbtn_XZ.state = false
				)
			)
			else
			(
				chkbtn_XZ.state = true
			)
		)
		on chkbtn_YZ changed theState do
		(
			if theState then
			(
				if CheckObjAndFaceSelection() == true then
				(
					chkbtn_XY.state = false
					chkbtn_XZ.state = false
					spn_extrudeAmount.enabled = on
				)
				else
				(
					chkbtn_YZ.state = false
				)
			)
			else
			(
				chkbtn_YZ.state = true
			)
		)
		
		on chkbtn_about changed theState do
		(
			if theState then
			(
				for h=184 to 384 by 5 do  PolyStraightExtrude.width = h
			)
			else
			(
				for h=384 to 184 by -5 do  PolyStraightExtrude.width = h
			)
		)
		
		on PolyStraightExtrude close do
		(
			theHold.cancel()
			try(delete tempObj)catch()
			curObj = undefined
			tempObj = undefined
			spn_extrudeAmount.value = 1.0
			redrawViews()			
		)		
	)
	createdialog PolyStraightExtrude width:184 height:80 style:#(#style_titlebar, #style_sysmenu, #style_toolwindow)
)