--******************************************************************************************************
-- Created: 		05-10-2011
-- Last Updated:	18-08-2011
--
-- Author :  Kostadin Kotev / miau_u@yahoo.com /
-- Version:  3ds max 9 and up
--
-- Discription: 
--	miauu's scripts Installator
--******************************************************************************************************
-- MODIFY THIS AT YOUR OWN RISK

(
	try ( destroyDialog rol_WorkPlane_Installation ) catch ()
	rollout rol_WorkPlane_Installation "Smart Poly Extrude"
	(
		local tempWorkPlaneFolder = pathConfig.GetDir #temp+"\\_tempFolder"
		local workPlaneMainFolder = pathConfig.GetDir #userscripts+"\\miauuScripts"
		
-- 		ImgTag ImgTag_BG bitmap:(bitmap 2 2 color:gray) pos:[0,0]  \
-- 			width:355 height:135 opacity:1 transparent:(color 0 255 255) enabled:off
		
		button btn_Install "Install" width:350 height:30 pos:[1,1]
		-- button btn_Uninstall "Uninstall" width:175 height:30 pos:[177,1]

		
		function DeleteDirAndSubDir rootDir =
		(
			try ( DOSCommand ("rmDir \"" + rootDir + "\" /s /q") ) catch (messagebox "Can't delete \"miauu's Work Plane\" folders!" title:"miauu's Work Plane Install Error!!!")
		)
		function DeleteFiles curDir file =
		(
			filesToDelete = getFiles (curDir + file)
			for f in filesToDelete do deleteFile f
		)
		
		function ValidateDirectory _dirNameIn  =
		(
			local _dirName = copy _dirNameIn
			local c
			for i = _dirName.count to 1 by -1 while (c=_dirName[i]; c=="\\" or c== "/") do
				_dirName = subString _dirName 1 (i-1)
			
			if doesFileExist _dirName then
				dirExists = true
			else
				dirExists = false
			
			return dirExists
		)
		
		function InstallWorkPlane create =
		(
			if tempWorkPlaneFolder != "" then
			(
				--	create main folder
				local var_workPlaneMainFolder = if create == true then (makeDir workPlaneMainFolder) else true
				
				if var_workPlaneMainFolder != true then
				(
					messagebox "Unable to create main folder!" title:"miauu's Work Plane Installation Error!!!"
				)
				else
				(
					--	copy mse and mcr files
					if var_workPlaneMainFolder == true then
					(	
						--	copy all files
						allPreinstMCIfiles = (getFiles (tempWorkPlaneFolder+"\\*.*"))
						for mciFile in allPreinstMCIfiles do
						(	
							copyFile mciFile (workPlaneMainFolder+"\\"+filenameFromPath mciFile)						
						)
						allInstalledMCIfiles = (getFiles (workPlaneMainFolder+"\\*.*"))
						
							--	copy toolbar Icons
						for tBarIcoFiles in (getFiles (tempWorkPlaneFolder+"\\icons\\*.*")) do
						(	
							copyFile tBarIcoFiles (pathConfig.GetDir #userIcons+"\\"+filenameFromPath tBarIcoFiles)
						)	
							
						--	load macros
						allMCRfiles = (getFiles (workPlaneMainFolder+"\\*.mcr"))
						for mcrFile in allMCRfiles do
						(
							fileIn (mcrFile)								
						)
					)
					else
						messagebox "Unable to copy files to main folder" title:"Installation Error!!!"
					
					-- reload all toolbar icons. for max9 and above
					colorman.reInitIcons()
				)				
			)
			else
				messagebox "Insallation Error!!!" title:"Installation Error"
		)
			
		on rol_WorkPlane_Installation close do
		(
			if tempWorkPlaneFolder != "" do
			(
				DeleteFiles ((getDir #userscripts) + "\_tempFolder") "*.*"	
				DeleteDirAndSubDir tempWorkPlaneFolder				
			)
		)
		
		on btn_Install pressed do
		(
			if tempWorkPlaneFolder != "" then
			(
				if (ValidateDirectory workPlaneMainFolder) == false then
				(
					try
					(					
						DeleteFiles ((getDir #userscripts) + "\miauuScripts") "*.*"	--	delete the mse and mcr files
						DeleteDirAndSubDir ((getDir #userscripts) + "\miauuScripts")	--	delete folders								
						DeleteFiles ((getDir #userMacros) + "\\") "*_miauuSFP_*.*"	--	delete macro 
					)
					catch(messagebox "Failed to Uninstall!" title:"Installation Error")
					InstallWorkPlane true
					destroydialog rol_WorkPlane_Installation
				)
				else
				(
					InstallWorkPlane false
					destroydialog rol_WorkPlane_Installation
				)
			)
			else
				messagebox "Insallation Error!!!" title:"Installation Error"
		)
		
		on btn_Uninstall pressed do
		(				
			try
			(					
				DeleteFiles ((getDir #userscripts) + "\miauuScripts") "*SmartPolyExtrude*.*"	--	delete the mse and mcr files
				DeleteDirAndSubDir ((getDir #userscripts) + "\miauuScripts")	--	delete folders								
				DeleteFiles ((getDir #userMacros) + "\\") "*SmartPolyExtrude*.*"	--	delete macro 
			)
			catch(messagebox "Failed to Uninstall!" title:"Installation Error")
			--	delete tempWorkPlaneFolder
			if (tempWorkPlaneFolder != "") do
				DeleteDirAndSubDir tempWorkPlaneFolder
			
			destroydialog rol_WorkPlane_Installation
		)
	)
	createDialog rol_WorkPlane_Installation height:32 width:352 bgcolor:black style:#(#style_toolwindow,#style_sysmenu)
)